-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- PRESENTON


-- Auf allgemeine, stets verfgbare  Datenbank wechseln
USE [master]
GO

-- Housekeeping: Datenbank <Graph-Algorithmen> lschen, falls vorhanden, um sauber aufzusetzen
DROP DATABASE IF EXISTS [Vortrag_Graph_Algorithmen]
GO

-- Datenbank mit Standardeinstellungen anlegen, keine besonderen Konfigurationen fr
-- dieses Beispiel notwendig
CREATE DATABASE [Vortrag_Graph_Algorithmen]
	CONTAINMENT = NONE
	ON  PRIMARY 
	( NAME = N'Vortrag_Graph_Algorithmen', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL14.MSSQLSERVER\MSSQL\DATA\Vortrag_Graph_Algorithmen.mdf' , SIZE = 8192KB , MAXSIZE = UNLIMITED, FILEGROWTH = 65536KB )
	LOG ON 
	( NAME = N'Vortrag_Graph_Algorithmen_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL14.MSSQLSERVER\MSSQL\DATA\Vortrag_Graph_Algorithmen_log.ldf' , SIZE = 8192KB , MAXSIZE = 2048GB , FILEGROWTH = 65536KB )
GO

IF (1 = FULLTEXTSERVICEPROPERTY('IsFullTextInstalled'))
BEGIN
	EXEC [Vortrag_Graph_Algorithmen].[dbo].[sp_fulltext_database] @action = 'enable'
END
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET ANSI_NULL_DEFAULT OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET ANSI_NULLS OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET ANSI_PADDING OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET ANSI_WARNINGS OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET ARITHABORT OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET AUTO_CLOSE OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET AUTO_SHRINK OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET AUTO_UPDATE_STATISTICS ON 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET CURSOR_DEFAULT  GLOBAL 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET CONCAT_NULL_YIELDS_NULL OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET NUMERIC_ROUNDABORT OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET QUOTED_IDENTIFIER OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET RECURSIVE_TRIGGERS OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET  DISABLE_BROKER 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET TRUSTWORTHY OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET ALLOW_SNAPSHOT_ISOLATION OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET PARAMETERIZATION SIMPLE 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET READ_COMMITTED_SNAPSHOT OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET HONOR_BROKER_PRIORITY OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET RECOVERY FULL 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET  MULTI_USER 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET PAGE_VERIFY CHECKSUM  
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET DB_CHAINING OFF 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET FILESTREAM( NON_TRANSACTED_ACCESS = OFF ) 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET TARGET_RECOVERY_TIME = 60 SECONDS 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET DELAYED_DURABILITY = DISABLED 
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET QUERY_STORE = OFF
GO

ALTER DATABASE [Vortrag_Graph_Algorithmen] SET  READ_WRITE 
GO

