-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- A)

-- auf <richtige> Datenbak wechseln
USE [Vortrag_Graph_Algorithmen]
GO


-- ########################
-- ### Aufbauarbeiten ####
-- ########################

-- Dieses Schema ist fr die ersten Beispiele VOR der Graphen-DB gedacht
CREATE SCHEMA [relational]
GO

-- Dieses Schema wird zum Zwischenspeichern verwandt, um in ruhe Zwischenergebnisse im Vortrag zeigen zu knnen
CREATE SCHEMA [temp]
GO

-- B)

-- Tabelle erstellen
CREATE TABLE [relational].[Person](
       [ID] [bigint] NOT NULL,
       [Vorname] [nchar](20) NOT NULL,
       [Nachname] [nchar](20) NOT NULL,
CONSTRAINT [PK_Person] PRIMARY KEY CLUSTERED 
(
       [ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

-- Tabelle mit Inhalt fllen, der zum Beispiel aus der Prsentation passt
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 1, 'Max', 'Mustermann')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 2, 'Donalt', 'Dack')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 3, 'Mycki', 'Maus')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 4, 'Schneewiddchen', 'Grymm')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 5, 'Bibi', 'LongStromp')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 6, 'Maggy', 'Thtscher')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 7, 'Johnny', 'MacLaine')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 8, 'Rischar', 'Klaidrmann')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES ( 9, 'Brijitte', 'Bardoh')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (10, 'Jiowanni', 'Trabbatohny')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (11, 'Teigar', 'Wudz')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (12, 'Bobbele', 'Bckr')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (13, 'Pohl', 'MakHartnei')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (14, 'Oddfried', 'Preusla')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (15, 'Hlene', 'Fischa')
INSERT INTO [relational].[Person] ([ID], [Vorname], [Nachname]) VALUES (16, 'Ponzyus', 'Pilatous')
GO

-- C)

-- Tabelle BEKANNTSCHAFT erstellen
CREATE TABLE [relational].[Bekanntschaft](
       [ID] [bigint] NOT NULL,
       [PersonA] [bigint] NOT NULL,
       [PersonB] [bigint] NOT NULL,
	   [Spruenge] [int] NOT null,
	   [Gesamtpfad] [VARCHAR](50) NOT NULL,
CONSTRAINT [PK_Bekanntschaft] PRIMARY KEY CLUSTERED 
(
       [ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

-- Checkconstraints einrichten, die erzwingen, dass nur Personen aus der PERSON-Tabelle in die 
-- Tabelle BEKANNTSCHAFT eingegebene werden knnen
ALTER TABLE [relational].[Bekanntschaft]  WITH CHECK ADD  CONSTRAINT [FK_Bekanntschaft_PersonA] FOREIGN KEY([PersonA])
REFERENCES [relational].[Person] ([ID])
GO

ALTER TABLE [relational].[Bekanntschaft] CHECK CONSTRAINT [FK_Bekanntschaft_PersonA]
GO

ALTER TABLE [relational].[Bekanntschaft]  WITH CHECK ADD  CONSTRAINT [FK_Bekanntschaft_PersonB] FOREIGN KEY([PersonB])
REFERENCES [relational].[Person] ([ID])
GO

ALTER TABLE [relational].[Bekanntschaft] CHECK CONSTRAINT [FK_Bekanntschaft_PersonB]
GO


-- Tabelle BEKANNTSCHAFT mit Inhalt fllen, der zum Beispiel aus der Prsentation passt
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 1,  1,  2,  1, 1)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 2,  1,  5,  1,  1)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 3,  1, 12,  1,  1)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 4,  1, 15,  1,  1)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 5,  2,  3,  1,  2)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 6,  2,  5,  1,  2)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 7,  2,  7,  1,  2)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 8,  2, 13,  1,  2)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES ( 9,  3,  4,  1,  3)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (10,  3,  6,  1,  3)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (11,  3, 11,  1,  3)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (12,  4,  2,  1,  4)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (13,  4,  6,  1,  4)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (14,  4,  8,  1,  4)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (15,  5,  3,  1,  5)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (16,  5, 15,  1,  5)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (17,  5, 16,  1,  5)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (18,  6, 14,  1,  6)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (19,  7, 13,  1,  7)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (20,  8, 15,  1,  8)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (21,  9,  7,  1,  9)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (22,  9, 11,  1,  9)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (23,  9, 12,  1,  9)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (24, 10,  2,  1, 10)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (25, 10,  7,  1, 10)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (26, 10, 14,  1, 10)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (27, 11,  6,  1, 11)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (28, 11, 13,  1, 11)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (29, 12,  8,  1, 12)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (30, 13, 15,  1, 13)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (31, 13, 16,  1, 13)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (32, 14,  3,  1, 14)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (33, 14, 15,  1, 14)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (34, 15, 16,  1, 15)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (35, 16,  1,  1, 16)
INSERT INTO [relational].[Bekanntschaft] ([ID], [PersonA], [PersonB], [Spruenge], [Gesamtpfad]) VALUES (36, 16,  9,  1, 16)
GO

-- D)

CREATE TABLE [relational].[Weg](
	[StartID] [bigint] NOT NULL,
	[ZielID] [bigint] NOT NULL,
	[Spruenge] [int] NULL,
	[Gesamtpfad] [varchar](50) NOT NULL,
 CONSTRAINT [pkWeg] PRIMARY KEY CLUSTERED 
(
	[StartID] ASC,
	[ZielID] ASC,
	[Gesamtpfad] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO


CREATE TABLE [relational].[WegParameter](
	[StartID] [bigint] NOT NULL,
	[ZielID] [bigint] NOT NULL
 CONSTRAINT [pkWegParameter] PRIMARY KEY CLUSTERED 
(
	[StartID] ASC,
	[ZielID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO


