-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- A)

-- auf "richtige" Datenbank wechseln
USE [Vortrag_Graph_Algorithmen]
GO


SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- In der Tabelle WEGPARAMETER wird das StartID-ZielID-Prchen abgelegt
TRUNCATE TABLE [relational].[WegParameter];
GO

INSERT INTO [relational].[WegParameter]
           ([StartID]
           ,[ZielID])
     VALUES
           (6
           ,7)
GO


-- B)


TRUNCATE TABLE [relational].[Weg];

-- Alle denkbaren Wege mit einem Sprung auffhren (unter Beachtung der Pfeilrichtung, also gerichtet)
-- mchte man ungerichtete Verbindungen (wenn A B kennt kennt auch B A), ist die UNION-Klausel 
-- wieder einzukommentieren
INSERT INTO [relational].[Weg] ([StartID], [ZielID], [Spruenge], [Gesamtpfad])
	SELECT    [PersonA]																	AS [StartID]
			, [PersonB]																	AS [ZielID]
			, 1																			AS [Spruenge]
			, CONVERT(VARCHAR(2), [PersonA]) + ',' + CONVERT(VARCHAR(2), [PersonB])		AS [Gesamtpfad]
	FROM (	SELECT    [PersonA]
					, [PersonB] 
			FROM [relational].[Bekanntschaft] 
	--UNION 
	--SELECT	  [PersonB] 
	--		, [PersonA]
	--FROM [relational].[Bekanntschaft]
	) AS [Dummy];


-- C)

DECLARE @Anzahl	int;
SET @Anzahl =@@ROWCOUNT;

WHILE @Anzahl > 0
   BEGIN
		INSERT INTO [relational].[Weg] ([StartID], [ZielID], [Spruenge], [Gesamtpfad])
		SELECT [StartID], [ZielID], [Spruenge], [Pfad]
		FROM [relational].[vNeuerSprung] v
		WHERE NOT EXISTS (SELECT * FROM [relational].[Weg] as [t] 
			WHERE t.[StartID] = v.[StartID] and t.[ZielID] = v.[ZielID]);
		SET @Anzahl =@@ROWCOUNT;
	END 
GO


-- D)

-- ##################
-- ## Auswertungen ##
-- ##################
-- alle mglichen Wege vom Start zum Ziel
SELECT * FROM [relational].[Weg] 
ORDER BY [StartID], [ZielID];

-- Lsung des hier gesuchten Beispiels
SELECT * FROM [relational].[Weg] 
WHERE 1=1
		AND [StartID] IN (SELECT [StartID] FROM [relational].[WegParameter])
		AND [ZielID] IN (SELECT [ZielID] FROM [relational].[WegParameter]);







