-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################


-- A)

-- auf "richtige" Datenbank wechseln
USE [Vortrag_Graph_Algorithmen]

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


-- Prozedur als CTE-Variante einspielen. Prozedur erwartet zwei Parameter (Start und Ziel)
CREATE OR ALTER PROCEDURE [relational].[SucheVerbindungCTE] 
	  @PersonA AS BIGINT
	, @PersonB AS BIGINT
AS
BEGIN
	SET NOCOUNT ON;

	;WITH cte 
	( 
			  [StartPerson]
			, [ZielPerson] 
			, [Steps] 
			, [PersonenIds] 
	) 
	AS ( 
			-- Initialisierung der Rekursion
			SELECT 
					  [v].[PersonA]
					, [v].[PersonB]
					, 0 
					, CAST(' ' + CONVERT(VARCHAR, [v].[PersonA]) 
						+ ' ' + CONVERT(VARCHAR, [v].[PersonB])
						+ ' ' AS VARCHAR(MAX)) 
			FROM [relational].[Bekanntschaft] AS v 
			WHERE 1 = 1 
					AND [PersonA] = @PersonA 
        
			UNION ALL 
        
			-- Rekursion
			SELECT 
					  [v].[PersonA]
					, [v].[PersonB] 
					, Steps+1 
					, CAST([cte].[PersonenIds] + CONVERT(VARCHAR, [v].[PersonB]) + ' ' AS VARCHAR(MAX)) 
			FROM [cte] 
			INNER JOIN [relational].[Bekanntschaft] AS [v] ON [v].[PersonA] = [cte].[ZielPerson]
			WHERE 1 = 1
					-- Abbruchbedingung fr Rekursion
					AND [cte].[PersonenIds] NOT LIKE '% ' + CONVERT(VARCHAR, [v].[PersonB]) + ' %' 
	) 
	SELECT 
			  Steps+1 AS Schritte 
			, LTRIM(RTRIM([PersonenIds])) AS Bekanntschaft 
	FROM [cte] 
	WHERE 1 = 1 
			  AND [PersonenIds] LIKE '% ' + CONVERT(VARCHAR, @PersonB) + ' ' 
	ORDER BY [Steps] asc 
END
GO
