-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf <richtige> Datenbak wechseln
USE [Vortrag_Graph_Algorithmen]
GO


SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- Erstellen der Prozedur SUCHEVERBINDUNG im Schema GRAPH
CREATE OR ALTER PROCEDURE [graph].[SucheVerbindung]
	  @PersonA as BIGINT
	, @PersonB as BIGINT
AS
BEGIN
	SET NOCOUNT ON;

	SELECT
		  [PersonA].[ID]							AS [PersonA ID]
		, [PersonA].[Vorname]						AS [PersonA Vorname]
		, [PersonA].[Nachname]						AS [PersonA Nachname]
		, 'kennt'									AS [Verb]
		, [PersonB].[ID]							AS [PersonB ID]
		, [PersonB].[Vorname]						AS [PersonB Vorname]
		, [PersonB].[Nachname]						AS [PersonB Nachname]
	FROM [graph].[Person] as [PersonA], [graph].[kennt], [graph].[Person] as [PersonB]
	WHERE MATCH ([PersonA]-(kennt)->[PersonB])
		AND [PersonA].[ID] = @PersonA
		AND [PersonB].[ID] = @PersonB

END
GO

