-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf <richtige> Datenbak wechseln
USE [Vortrag_Graph_Algorithmen]
GO

-- ############################
-- ## direkte Bekanntschaft ###
-- ############################
-- positives Beispiel sind die IDs 1 und 2
-- negatives Beispiel sind die IDs 6 und 7
DECLARE @RC int
DECLARE @PersonA bigint
DECLARE @PersonB bigint

SET @PersonA = 1
SET @PersonB = 2

EXECUTE @RC = [graph].[SucheVerbindung] 
   @PersonA
  ,@PersonB
GO



-- #####################################
-- ## Bekanntschaften ber 3 Sprnge ###
-- #####################################
DECLARE @MaxSpruenge		INTEGER = 3;
DECLARE @StartID			INTEGER = 6;
WITH
BekannteEinigeSpruengeEntfernt([Start ID], [Start Vorname], [Start Nachname], [Ziel ID], [Ziel Vorname], [Ziel Nachname], [AnzahlSpruenge]) AS
(
	SELECT    [S].[ID]										AS [Start ID]
			, [S].[Vorname]									AS [Start Vorname]
			, [S].[Nachname]								AS [Start Nachname]
			, [Z].[ID]										AS [Ziel ID]
			, [Z].[Vorname]									AS [Ziel Vorname]
			, [Z].[Nachname]								AS [Ziel Nachname]
			,  1											AS [AnzahlSpruenge]
	 FROM [graph].[Person] [S], [graph].[Person] [Z], [graph].[kennt] [kennt]
	WHERE MATCH([S]-([kennt])-> [Z])
	  AND [S].[ID] = 6
	UNION ALL
	SELECT	  [S].[ID]										AS [Start ID]
			, [S].[Vorname]									AS [Start Vorname]
			, [S].[Nachname]								AS [Start Nachname]
			, [Z].[ID]										AS [Ziel ID]
			, [Z].[Vorname]									AS [Ziel Vorname]
			, [Z].[Nachname]								AS [Ziel Nachname]
			, [AnzahlSpruenge] + 1							AS [AnzahlSpruenge]
	FROM [graph].[Person] [S], [graph].[Person] [Z], [graph].[kennt] [kennt], [BekannteEinigeSpruengeEntfernt] [BESE]
	WHERE MATCH([S]-([kennt])-> [Z]) 
	AND [BESE].[Ziel ID] = [S].[ID]
	AND [AnzahlSpruenge] < @MaxSpruenge
) 

SELECT DISTINCT 
	  [BESE].[Ziel ID] 
	, [BESE].[Ziel Vorname]
	, [BESE].[Ziel Nachname]
--SELECT * 
FROM [BekannteEinigeSpruengeEntfernt] [BESE]
WHERE 1=1 
	AND [AnzahlSpruenge] = @MaxSpruenge

