-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript importiert die Rohdaten aus der Beispieldatenbank. Diese wurde    ##
-- ## vorab mit frei verfgbaren Daten der Webseite Kaggle.com aufgebaut.             ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################


-- Skript luft auf dieser Hardware ca. 3 Minuten

USE [Vortrag_Graph_Algorithmen]

-- bestehende Tabelle FLUGHAFEN im Schema RELATIONAL lschen, um sauber wieder aufzusetzen
DROP TABLE IF EXISTS [relational].[Flugplan]
GO


SELECT 
		  [Origin_airport]			AS [Startflughafen]
		, [Destination_airport]		AS [Zielflughafen]
		, [Origin_city]				AS [StartOrt]
		, [Destination_city]		AS [ZielOrt]
		, [Passengers]				AS [PassagiereAufFluegen]
		, [Seats]					AS [SitzeGesamt]
		, [Flights]					AS [Fluege]
		, [Distance]				AS [DistanzInMeilen]
		, [Fly_date]				AS [Flugdatum]
		, [Origin_population]		AS [EinwohnerZahlStartOrt]
		, [Destination_population]	AS [EinwohnerzahlZielOrt]
		, [Org_airport_lat]			AS [BreitengradStartflughafen]
		, [Org_airport_long]		AS [LaengengradStartflughafen]
		, [Dest_airport_lat]		AS [BreitengradZielflughafen]
		, [Dest_airport_long]		AS [LaengengradZielflughafen]
INTO [relational].[Flugplan]  
FROM [Vortrag_Rohdaten].[dbo].[Import_Rohdaten_Flughafen]
WHERE 1=1 
	AND [Org_airport_lat] IS NOT NULL
	AND [Org_airport_long] IS NOT NULL
	AND [Dest_airport_lat] IS NOT NULL
	AND [Dest_airport_long] IS NOT NULL;  




ALTER TABLE [relational].[Flugplan] ALTER COLUMN [Fluege] INTEGER;  
GO  
ALTER TABLE [relational].[Flugplan] ALTER COLUMN [SitzeGesamt] INTEGER;  
GO  
ALTER TABLE [relational].[Flugplan] ALTER COLUMN [PassagiereAufFluegen] INTEGER;  
GO  
ALTER TABLE [relational].[Flugplan] ALTER COLUMN [DistanzInMeilen] INTEGER;  
GO  
ALTER TABLE [relational].[Flugplan] ALTER COLUMN [Flugdatum] DATE;  
GO  
ALTER TABLE [relational].[Flugplan] ALTER COLUMN [EinwohnerZahlStartOrt] BIGINT;  
GO  
ALTER TABLE [relational].[Flugplan] ALTER COLUMN [EinwohnerzahlZielOrt] BIGINT;  
GO  



SELECT
	  MIN([Flugdatum])							AS [Beginn Betrachtungszeitraum]
	, MAX([Flugdatum])							AS [Ende Betrachtungszeitraum] 
	, count(*)									AS [Anzahl Datenstze]
FROM [relational].[Flugplan]
