-- #####################################################################################
-- ## Skript zum Vortrag <Die Algorithmen hinter Xing, Facebooks und Navis...>        ##     
-- #####################################################################################
-- ## Dieses Skript fragt den gewnschten Flugplan mit heutigen Mitteln aus einer     ##
-- ## Graph-Datenbank ab.                                                             ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## nderungsnachweis:                                                              ##
-- ## 2019-06-29		Neuerstellung                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################


USE [Vortrag_Graph_Algorithmen]

-- PIT --> ATL --> DET
SELECT	
	  [Startflughafen]
	, [Flug]
FROM (  
   SELECT
         [FH1].[Startflughafen] AS [Startflughafen]
	   , STRING_AGG([FH2].[Startflughafen], '->') WITHIN GROUP (GRAPH PATH) AS [Flug]
       , LAST_VALUE([FH2].[Startflughafen]) WITHIN GROUP (GRAPH PATH) AS [LastNode]
   FROM
		  [Flughafen] AS [FH1]
		, [fliegt_nach] FOR PATH AS [fn]
		, [Flughafen] FOR PATH  AS [FH2]
   WHERE MATCH(SHORTEST_PATH([FH1](-(fn)->[FH2])+))
   AND [FH1].[Startflughafen] = 'PIT'
) AS Q
WHERE Q.LastNode = 'DET'



-- RestoreDefaultFonts